# biosim-client.api.biosim

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The `biosim_client.api.biosim` package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.2.0
- Package version: 1.0.0
- Generator version: 7.10.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.8+

## Installation & Usage

This python library package is generated without supporting files like setup.py or requirements files

To be able to use it, you will need these dependencies in your own package that uses this library:

- urllib3 >= 1.25.3, < 3.0.0
- python-dateutil >= 2.8.2
- pydantic >= 2
- typing-extensions >= 4.7.1

## Getting Started

In your own code, to use this library to connect and interact with biosim-client.api.biosim,
you can run the following:

```python

import biosim_client.api.biosim
from biosim_client.api.biosim.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = biosim_client.api.biosim.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
with biosim_client.api.biosim.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = biosim_client.api.biosim.VerificationApi(api_client)
    workflow_id = 'workflow_id_example' # str |

    try:
        # Retrieve verification report for OMEX/COMBINE archive
        api_response = api_instance.get_verify_output(workflow_id)
        print("The response of VerificationApi->get_verify_output:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling VerificationApi->get_verify_output: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to _http://localhost_

| Class             | Method                                                                                             | HTTP request                  | Description                                                            |
| ----------------- | -------------------------------------------------------------------------------------------------- | ----------------------------- | ---------------------------------------------------------------------- |
| _VerificationApi_ | [**get_verify_output**](biosim_client/api/biosim/docs/VerificationApi.md#get_verify_output)        | **GET** /verify/{workflow_id} | Retrieve verification report for OMEX/COMBINE archive                  |
| _VerificationApi_ | [**verify_omex**](biosim_client/api/biosim/docs/VerificationApi.md#verify_omex)                    | **POST** /verify/omex         | Request verification report for OMEX/COMBINE archive across simulators |
| _VerificationApi_ | [**verify_runs**](biosim_client/api/biosim/docs/VerificationApi.md#verify_runs)                    | **POST** /verify/runs         | Request verification report for biosimulation runs by run IDs          |
| _DefaultApi_      | [**get_version_version_get**](biosim_client/api/biosim/docs/DefaultApi.md#get_version_version_get) | **GET** /version              | Get Version                                                            |
| _DefaultApi_      | [**root_get**](biosim_client/api/biosim/docs/DefaultApi.md#root_get)                               | **GET** /                     | Root                                                                   |

## Documentation For Models

- [BiosimSimulationRun](biosim_client/api/biosim/docs/BiosimSimulationRun.md)
- [BiosimSimulationRunStatus](biosim_client/api/biosim/docs/BiosimSimulationRunStatus.md)
- [BiosimulatorVersion](biosim_client/api/biosim/docs/BiosimulatorVersion.md)
- [CompareSettings](biosim_client/api/biosim/docs/CompareSettings.md)
- [ComparisonStatistics](biosim_client/api/biosim/docs/ComparisonStatistics.md)
- [GenerateStatisticsActivityOutput](biosim_client/api/biosim/docs/GenerateStatisticsActivityOutput.md)
- [HDF5Attribute](biosim_client/api/biosim/docs/HDF5Attribute.md)
- [HDF5Dataset](biosim_client/api/biosim/docs/HDF5Dataset.md)
- [HDF5File](biosim_client/api/biosim/docs/HDF5File.md)
- [HDF5Group](biosim_client/api/biosim/docs/HDF5Group.md)
- [HTTPValidationError](biosim_client/api/biosim/docs/HTTPValidationError.md)
- [Hdf5DataValues](biosim_client/api/biosim/docs/Hdf5DataValues.md)
- [RunData](biosim_client/api/biosim/docs/RunData.md)
- [SimulationRunInfo](biosim_client/api/biosim/docs/SimulationRunInfo.md)
- [ValidationError](biosim_client/api/biosim/docs/ValidationError.md)
- [ValidationErrorLocInner](biosim_client/api/biosim/docs/ValidationErrorLocInner.md)
- [Value](biosim_client/api/biosim/docs/Value.md)
- [VerifyWorkflowOutput](biosim_client/api/biosim/docs/VerifyWorkflowOutput.md)
- [VerifyWorkflowStatus](biosim_client/api/biosim/docs/VerifyWorkflowStatus.md)

<a id="documentation-for-authorization"></a>

## Documentation For Authorization

Endpoints do not require authorization.

## Author
