# biosim-client.api.simdata

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The `biosim_client.api.simdata` package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.0
- Generator version: 7.10.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.8+

## Installation & Usage

This python library package is generated without supporting files like setup.py or requirements files

To be able to use it, you will need these dependencies in your own package that uses this library:

- urllib3 >= 1.25.3, < 3.0.0
- python-dateutil >= 2.8.2
- pydantic >= 2
- typing-extensions >= 4.7.1

## Getting Started

In your own code, to use this library to connect and interact with biosim-client.api.simdata,
you can run the following:

```python

import biosim_client.api.simdata
from biosim_client.api.simdata.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = biosim_client.api.simdata.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
with biosim_client.api.simdata.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = biosim_client.api.simdata.DefaultApi(api_client)

    try:
        # Health
        api_response = api_instance.get_health()
        print("The response of DefaultApi->get_health:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DefaultApi->get_health: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to _http://localhost_

| Class        | Method                                                                        | HTTP request                        | Description        |
| ------------ | ----------------------------------------------------------------------------- | ----------------------------------- | ------------------ |
| _DefaultApi_ | [**get_health**](biosim_client/api/simdata/docs/DefaultApi.md#get_health)     | **GET** /health                     | Health             |
| _DefaultApi_ | [**get_metadata**](biosim_client/api/simdata/docs/DefaultApi.md#get_metadata) | **GET** /datasets/{run_id}/metadata | Hdf5 File Metadata |
| _DefaultApi_ | [**get_modified**](biosim_client/api/simdata/docs/DefaultApi.md#get_modified) | **GET** /datasets/{run_id}/modified | Modified Datetime  |
| _DefaultApi_ | [**read_dataset**](biosim_client/api/simdata/docs/DefaultApi.md#read_dataset) | **GET** /datasets/{run_id}/data     | Read Dataset       |
| _DefaultApi_ | [**root_get**](biosim_client/api/simdata/docs/DefaultApi.md#root_get)         | **GET** /                           | Root               |

## Documentation For Models

- [DatasetData](biosim_client/api/simdata/docs/DatasetData.md)
- [HDF5Attribute](biosim_client/api/simdata/docs/HDF5Attribute.md)
- [HDF5Dataset](biosim_client/api/simdata/docs/HDF5Dataset.md)
- [HDF5File](biosim_client/api/simdata/docs/HDF5File.md)
- [HDF5Group](biosim_client/api/simdata/docs/HDF5Group.md)
- [HTTPValidationError](biosim_client/api/simdata/docs/HTTPValidationError.md)
- [Status](biosim_client/api/simdata/docs/Status.md)
- [StatusResponse](biosim_client/api/simdata/docs/StatusResponse.md)
- [ValidationError](biosim_client/api/simdata/docs/ValidationError.md)
- [ValidationErrorLocInner](biosim_client/api/simdata/docs/ValidationErrorLocInner.md)
- [Value](biosim_client/api/simdata/docs/Value.md)

<a id="documentation-for-authorization"></a>

## Documentation For Authorization

Endpoints do not require authorization.

## Author
